/*** stmodem.cpp ***/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <time.h>
#include <dos.h>

#include "pcl4c.h"
#include "ascii.h"
#include "term_io.h"
#include "stpacket.h"
#include "stmodem.h"
#include "timing.h"
#include "win_io.h"
#include "workfile.h"
#include "calc.h"

#include "term.cfg"

#define ABORT_CHAR CAN
#define FALSE 0
#define TRUE !FALSE

#define DEBUG 0

void InitStatRnd(int);
int StatRnd(void);
static float ChanceNumber = 0.1;

static int DataBits = WordLength8;
static int StopBits = OneStopBit;
static int Parity = NoParity;

static void Set8N1(int Port)
{int  PSL;
 PSL = SioRead(Port,3);
 DataBits = 0x03 & PSL;
 StopBits = 0x01 & (PSL>>2);
 Parity = 0x07 & (PSL>>3);
 /* set 8N1 */
 SioParms(Port,NoParity,OneStopBit,WordLength8);
}

static void RestorePSL(int Port)
{/* ⠭  ࠬ஢ */
 SioParms(Port,Parity,StopBits,DataBits);
}

int TStatModem(
   int Port,            /* COM  [0..3] */
   char *Buffer,        /*   */
   int Number1K,        /*  ᫮ ⮢ */
   int *ErrorPacket,    /* ᫮ 訡 ⮢ */
   int *PacketTX)       /* ᫮  । ⮢ */
{int  i, k;
 long Tics;
 char c;
 char Type = 'T';	/*  WriteCPS */
 extern int PacketSize;
 char NCGchar = NAK;
 char Temp[81];

 extern int CheckitByte;
 extern int Time;

 time_t Start;
 /* 砫 */
 Set8N1(Port);
 WriteMsg("StatMODEM send: waiting for Receiver ");
 while(SioKeyPress()) SioKeyRead();

 /* ⪠ COM  ( there may be several NAKs queued up ) */
 SioRxFlush(Port);
 /* get receivers start up 'S' */
 if(!TxStartup(Port,&NCGchar))
 {RestorePSL(Port);
  return(FALSE);
 }

 /* । ⮢ */
 SioDelay(ONE_SECOND/4);
 (void)time(&Start);
 for(*PacketTX = 0;*PacketTX<=Number1K;*PacketTX = *PacketTX + 1)
 {/* ஢ઠ 뢠  짮⥫? */
      if(SioKeyPress()) if((char)SioKeyRead() == ABORT_CHAR)
      {TxCAN(Port);
       Tics = time(NULL) - Start;
       i = WriteCPS(Tics,PacketSize,*PacketTX-1,*ErrorPacket,Type);
       sprintf(Temp,"Counte receive packets %d CPS = %d\n User aborts",*PacketTX,i);
       WriteInFile(Temp);
       WriteFile_(Temp);
       WriteMsg("Aborted by USER");
       Tics = (int)(time(NULL) - Start)/60;
       sprintf(Temp,"Time works = %d min",Tics);
       WriteFile(Temp);
       WriteTime_(Temp);
       RestorePSL(Port);
       return(FALSE);
      }
 Tics = time(NULL) - Start;
 WriteCPS(Tics,PacketSize,*PacketTX-1,*ErrorPacket,Type);
 /* 㧪   */
 if(*PacketTX==0)
      {/* ନ஢ 㫥  */
       k = 0;
       sprintf(Temp,"%d",PacketSize);
       for(i=0;i<strlen(Temp);i++) Buffer[k++] = Temp[i];
       Buffer[k++] = '\0';
       Buffer[k++] = CheckitByte + 48;
       Buffer[k++] = '\0';
       sprintf(Temp,"%d",Time);
       for(i=0;i<strlen(Temp);i++) Buffer[k++] = Temp[i];
       while(k<16) Buffer[k++] = '\0';
      }
 else /* p > 0 */
      {/* ନ஢  : 32K ... 16  */
	 InitStatRnd(*PacketTX);
	 for(i=0;i<PacketSize;i++){
          k=StatRnd();
          if(k < 25 || k == 255) i--;
          else Buffer[i] = k;
	 }
      }
 /* 뫪  */
 if(*PacketTX==0){
 if(!TxPacket(Port,PacketTX,16,Buffer,NCGchar,ErrorPacket))
   {RestorePSL(Port);
    TxCAN(Port);
    sprintf(Temp," । 㫥 ");
    WriteFile(Temp);
    WriteFile_(Temp);
    return(FALSE);
   }
 }
 else if(*PacketTX!=0){
 if(!TxPacket(Port,PacketTX,PacketSize,Buffer,NCGchar,ErrorPacket))
   {RestorePSL(Port);
    TxCAN(Port);
    i = WriteCPS(Tics,PacketSize,*PacketTX-1,*ErrorPacket,Type);
    sprintf(Temp,"Number transfer packets %d CPS = %d\nPacket timeout-TX",*PacketTX,i);
    WriteInFile(Temp);
    WriteFile_(Temp);
    Tics = (int)(time(NULL) - Start)/60;
    sprintf(Temp,"Time works = %d min",Tics);
    WriteTime_(Temp);
    WriteFile(Temp);
    return(FALSE);
   }
 }
 /* । ६ ࠡ */
 if( ( time(NULL)-Start ) > ( Time*60 ) ){
	i = WriteCPS(Tics,PacketSize,*PacketTX-1,*ErrorPacket,Type);
	sprintf(Temp,"Number transfer packets %d CPS = %d",*PacketTX,i);
	WriteInFile(Temp);
   	WriteFile_(Temp);
	goto cont;
    }
 } /* end -- for(p) */
cont:

 /* 뫪 EOT ᫥ ᯥ譮 ।  ⮢  */
 if(!TxEOT(Port))
 {TxCAN(Port);
  sprintf(Temp,"EOT not acknowledged");
  WriteFile(Temp);
  WriteFile_(Temp);
  WriteMsg(Temp);
  RestorePSL(Port);
  return(FALSE);
 }
 Tics = (int)(time(NULL) - Start)/60;
 sprintf(Temp,"Transfer Complete\nTime works = %d min",Tics);
 WriteFile(Temp);
 WriteTime_(Temp);
 WriteMsg("Transfer Complete");
 RestorePSL(Port);
 return(TRUE);
} /* end -- TStatModem */

int RStatModem(
   int Port,                /* COM port [0..3] */
   char *Buffer,            /*   */
   char NCGparm,            /* 'S' */
   int *ErrorPacket,        /* ᫮ 訡 ⮢ */
   long *ErrorByte,         /* ᫮ 訡  */
   long *ErrorBit,          /* ᫮ 訡  */
   long *ErrorBit_1_in_0,   /* ᫮ 室  1  0 */
   long *ErrorBit_0_in_1,   /* ᫮ 室  0  1 */
   int *ErrorPacketCRC,     /* ᫮ ⮢  訡 CRC */
   int *ErrorPacketSize,    /* ᫮  ⮢ */
   int *ErrorPacketACK,     /* ᫮ ⢥ত ⮢*/
   int *PacketRX)           /* ᫮ ਭ ⮢ */
{int  i;
 extern int  PacketSize;    /* 16 ... 32768 */
 char Temp[81];
 long Tics;                 /* ६  砫 ਥ  ᥪ㭤 */
 int  EOTflag = FALSE;
 char NCGchar;
 char Type = 'R';           /*  WriteCPS */

 extern int CheckitByte;
 extern int Time;	    /* ⢥ ६  ਥ */
 extern int Time1;	    /* ६  砫 ਥ   */
 time_t Start;

 /* 砫 */
 NCGchar = NCGparm;
 Set8N1(Port);
 EOTflag = FALSE;
 WriteMsg("StatMODEM Receive: Waiting for Sender ");
 while(SioKeyPress()) SioKeyRead();
 /* ⪠ COM  */
 SioRxFlush(Port);
 /* 뫪 'S' */
 if(!RxStartup(Port,&NCGchar))
 {RestorePSL(Port);
  return(FALSE);
 }

 /* ਥ ⮢ */
 (void)time(&Start);
 for(*PacketRX = 0;;*PacketRX = *PacketRX + 1)
 {/* ஢ઠ 뢠  짮⥫? */
    if(SioKeyPress()) if((char)SioKeyRead()==ABORT_CHAR)
    {TxCAN(Port);
     RestorePSL(Port);
     Tics = time(NULL) - Start;
     sprintf(Temp,"\n");
     WriteInFile_(Temp);
     i = WriteCPS(Tics,PacketSize,*PacketRX-1,*ErrorPacket,Type);
     sprintf(Temp,"Counte receive packets %d CPS = %d\nUser aborts",*PacketRX,i);
     WriteInFile(Temp);
     WriteFile_(Temp);
     WriteMsg("Aborted by USER");
     Tics = (int)(time(NULL) - Start)/60;
     sprintf(Temp,"Time works = %d min",Tics);
     WriteFile(Temp);
     WriteTime_(Temp);
     return(FALSE);
    }
     Tics = time(NULL) - Start;
     WriteCPS(Tics,PacketSize,*PacketRX-1,*ErrorPacket,Type);
     Time1 = (int)((Tics+3)/60);
    /* ।  */
     if(!RxPacket(Port,PacketRX,&PacketSize,Buffer,NCGchar,&EOTflag,ErrorPacket,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,ErrorPacketCRC,ErrorPacketSize,ErrorPacketACK))
     {RestorePSL(Port);
      TxCAN(Port);
      sprintf(Temp,"\n");
      WriteInFile_(Temp);
      Tics = time(NULL) - Start;
      i = WriteCPS(Tics,PacketSize,*PacketRX-1,*ErrorPacket,Type);
      sprintf(Temp,"Counte receive packets %d CPS = %d\nPacket timeout-RX",*PacketRX,i);
      WriteInFile(Temp);
      WriteFile_(Temp);
      WriteMsg("Packet timeout-RX");
      Tics = (int)(time(NULL) - Start)/60;
      sprintf(Temp,"Time works = %d min",Tics);
      WriteFile(Temp);
      WriteTime_(Temp);
      return(FALSE);
    }
      /* ਥ ᯥ襭, ᫨ ਭ EOT */
      if(EOTflag)
      {
       sprintf(Temp,"\n");
       WriteInFile_(Temp);
       Tics = time(NULL) - Start;
       i = WriteCPS(Tics,PacketSize,*PacketRX-1,*ErrorPacket,Type);
       sprintf(Temp,"Counte receive packets %d CPS = %d\nReceiver Complete",*PacketRX,i);
       WriteInFile(Temp);
       WriteFile_(Temp);
       WriteMsg("Receiver Complete");
       Tics = (int)(time(NULL) - Start)/60;
       sprintf(Temp,"Time works = %d min",Tics);
       WriteFile(Temp);
       WriteTime_(Temp);
       RestorePSL(Port);
       return(TRUE);
      }
      /* ࠡ⪠ 㫥  0 */
      if(*PacketRX == 0)
      {
       /* ࠧ   */
       PacketSize = atoi(strcpy(Temp,Buffer));
       /* ᫮  ஢筮 樨 */
       CheckitByte = atoi(&Buffer[1+strlen(Buffer)]);
       /* ६ ਥ */
       Time = atoi(&Buffer[3+strlen(Buffer)]);
       sprintf(Temp,"PacketSize=%d Check=%d Time=%d",PacketSize,CheckitByte,Time);
       WriteInFile(Temp);
       WriteFile_(Temp);
       sprintf(Temp,"Ŀ\n");
       WriteInFile_(Temp);
       sprintf(Temp,"          ६           ᫮   \n");
       WriteInFile_(Temp);
       sprintf(Temp,"   訡   ਭ            訡\n");
       WriteInFile_(Temp);
       sprintf(Temp,"                        訡   訡       \n");
       WriteInFile_(Temp);
       sprintf(Temp,"Ĵ\n");
       WriteInFile_(Temp);
#if DEBUG
sprintf(Temp,"PS=%d CB=%d T=%d",PacketSize,CheckitByte,Time);
WinPutString(SCR_WIN,Temp);
#endif
      }
     } /* end -- for(p) */
} /* end - RStatModem */

int TxCAN(int Port)
{int i;
 for(i=0;i<6;i++) SioPutc(Port,CAN);
 return(0);
}

/* StatMODEM, । */

void SmodemTx(int Port,char *Buffer)
{
 char Temp[81];
 int PacketTX = 0;	   /* ᫮  ⮢ */
 int ErrorPacket = 0;	   /* ᫮ 訡 ⮢ */
 extern int PacketSize,CheckitByte,Time;
 extern char Speed[];
 long _Number;
 sprintf(Temp,"Mode Transfer StatModem");
 WriteTime_(Temp);
 WriteFile(Temp);
 sprintf(Temp,"%s",Speed);
 _Number=Calc(Temp);
 sprintf(Temp,"Wait %ld packets length %d byte",_Number, PacketSize);
 WriteInFile(Temp);
 sprintf(Temp,"PacketSize = %d CheckitByte = %d Time = %d\n",
	       PacketSize,CheckitByte,Time);
 WriteInFile(Temp);
 WriteInFile_(Temp);
 TStatModem(Port,Buffer,(int)_Number,&ErrorPacket,&PacketTX);
 sprintf(Temp,"ᥣ ⮢ = %d",PacketTX-1+ErrorPacket);
 WriteFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮  ⮢ = %d",PacketTX-1);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ 訡 ⮢ = %d\n",ErrorPacket);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sound(5000);
 fcloseall();
 nosound();
 NameFile();
 NameFileTab();
}

/* StatMODEM, ਥ */

void SmodemRx(int Port,char *Buffer,char NCGchar)
{char Temp[80];
 int PacketRX;		   /* ᫮  ⮢ */
 int ErrorPacket = 0;	   /* ᫮ 訡 ⮢ */
 int ErrorPacketCRC = 0;   /* ᫮ ⮢  訡  CRC */
 int ErrorPacketSize = 0;  /* ᫮  ⮢ */
 int ErrorPacketACK = 0;   /* ᫮ ⮢  稢 ⢥ত */
 long ErrorByte = 0;	   /* ᫮ 訡  */
 long ErrorBit = 0;	   /* ᫮ 訡  */
 long ErrorBit_1_in_0 = 0; /* ᫮ 室  1  0 */
 long ErrorBit_0_in_1 = 0; /* ᫮ 室  0  1 */
 sprintf(Temp,"Mode Receive StatModem");
 WriteFile(Temp);
 WriteTime_(Temp);
 RStatModem(Port,Buffer,NCGchar,&ErrorPacket,&ErrorByte,&ErrorBit,&ErrorBit_1_in_0,&ErrorBit_0_in_1,&ErrorPacketCRC,&ErrorPacketSize,&ErrorPacketACK,&PacketRX);
 sprintf(Temp,"ᥣ ⮢ = %d.",PacketRX-1+ErrorPacket);
 WriteFile_(Temp);
 WriteFile(Temp);
 sprintf(Temp,"᫮  ⮢ = %d.",PacketRX-1);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ 訡 ⮢ = %d,  ⮬ ᫥:",ErrorPacket);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ ⮢  訡 CRC = %d,",ErrorPacketCRC);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮   ⮢ = %d.",ErrorPacketSize);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮  ⢥ত ⮢ = %d",ErrorPacketACK);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ 訡  = %ld\n",ErrorByte);
 WriteInFile(Temp);
 WriteFile_(Temp);
#if EBITE
 sprintf(Temp,"᫮ 訡  = %ld",ErrorBit);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ 室  1  0 = %ld",ErrorBit_1_in_0);
 WriteInFile(Temp);
 WriteFile_(Temp);
 sprintf(Temp,"᫮ 室  0  1 = %ld\n",ErrorBit_0_in_1);
 WriteInFile(Temp);
 WriteFile_(Temp);
#endif
 sound(5000);
 fcloseall();
 nosound();
 NameFile();
 NameFileTab();
}

#include "stat_rnd.cpp"
