/*** stpacket.cpp ***/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#include "pcl4c.h"
#include "term.h"
#include "crc16.h"
#include "ascii.h"
#include "term_io.h"
#include "timing.h"
#include "win_io.h"
#include "check.h"
#include "workfile.h"
#include "stmodem.h"

#include "term.cfg"

#define DEBUG 0

#define FALSE 0
#define TRUE !FALSE

#define MAXTRY 10
#define LIMIT 60
#define XYDELAY 1

void InitStatRnd(int);
int StatRnd(void);
static float ChanceNumber = 0.1;

void PacketError(int ,int ,char *);

int TxPacket(
   int Port,            /* COM  [0..3] */
   int *PacketNbr2,     /*    । */
   int PacketSize,      /* ࠧ  (   16 ... 32768 ) */
   char Buffer[],       /*   */
   char NCGchar,        /* 'S' */
   int *ErrorPacket)
{int  i;
 int Code;
 unsigned short CheckSum;
 int PacketNbr1;
 int PacketNbr;
 int Attempt;
 int PacketType;
 char Temp[81];
 int Full;

 /* 砫 */
 Full = GetBufSize();
#if DEBUG
sprintf(Temp,"[TxP: COM%d PacketNbr=%d PacketSize=%d NCGchar=%c]\n",
    1+Port,PacketNbr,PacketSize,NCGchar);
WinPutString(SCR_WIN,Temp);
#endif
 PacketType = SOH;
 PacketNbr = *PacketNbr2;
 PacketNbr1 = PacketNbr;
 PacketNbr &= 0x00ff;

 /* 뫪 ⮢, ᨬ쭮 MAXTRY ⮪ */
 for(Attempt=1;Attempt<=MAXTRY;Attempt++)
     {
   if(SioKeyPress())
     {sprintf(Temp,"Aborted by user");
      WriteMsg(Temp);
      TxCAN(Port);
      return(FALSE);
     }
      /* 뫪 SOH */
      Code = CharPut(Port,(char)PacketType);
      SioDelay(XYDELAY);
      /* 뫪 ⭮  */
      Code = CharPut(Port,(char)PacketNbr);
      /* 뫪    */
      Code = CharPut(Port,(char)(255-PacketNbr));
#if DEBUG
sprintf(Temp,"[TxP: PacketNbr=%d 255-PacketNbr=%d]\n",
    PacketNbr, 255-PacketNbr);
WinPutString(SCR_WIN,Temp);
#endif
      /* 뫪  */
      CheckSum = 0;
      for(i=0;i<PacketSize;i++)
	  {Code = CharPut(Port,Buffer[i]);
	   if(NCGchar==NAK) CheckSum += Buffer[i];
	   else CheckSum = UpdateCRC(Buffer[i],CheckSum);
	   if(i%32==0)
           {while(SioTxQue(Port)>=Full-32) SioDelay(1);
           }
	  }
      /* flush reverse channel */
      SioRxFlush(Port);
      /* 뫪 ஢筮 樨 */
      if(NCGchar==NAK)
      {Code = CharPut(Port,(char)(CheckSum & 0x00ff) );
      }
      else
      {Code = CharPut(Port, (char)((CheckSum>>8) & 0x00ff) );
       Code = CharPut(Port, (char)(CheckSum & 0x00ff) );
      }
      /*   ਥ ACK */
      SioDelay(XYDELAY);     /* ??? */
      Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
      if(Code==-1)
      {WriteMsg("No response from receiver");
       SioDelay(XYDELAY);
       goto Again1;
      }
      if((char)Code==CAN)
      {
       /* ਥ । ⬥! */
       Code = CharGet(Port,SSHORT_WAIT);
       if(Code == CAN){
         sprintf(Temp,"Canceled by REMOTE");
         PacketError(PacketNbr1,Attempt,Temp);
         return(FALSE);
        }
        SioDelay(XYDELAY);	     
        goto Again2;
       }
      if((char)Code==ACK) return(TRUE);
      if((char)Code!=NAK)
      {
       sprintf(Temp,"Not ACK/NAK/CAN");
       PacketError(PacketNbr1,Attempt,Temp);
       Attempt--;
       goto Again2;
      }
      /* । ⪠ */
Again1:
     sprintf(Temp,"From receiver NAK");
     PacketError(PacketNbr1,Attempt,Temp);
     *ErrorPacket = *ErrorPacket + 1;
Again2:
     }/* end -- for(Attempt) */

 /* ।   ! */
 TxCAN(Port);
 sprintf(Temp,"TX packet timeout");
 WriteFile(Temp);
 return(FALSE);
} /* end -- TxPacket */

int RxPacket(
   int Port,            /* COM  [0..3] */
   int *PacketNbr2,     /*    */
   int *PacketSizePtr,  /* ࠧ  (16  16...16384) */
   char Buffer[],       /*   */
   char NCGchar,        /* S */
   int *EOTptr,         /*  祭 EOT */
   int *ErrorPacket,
   long *ErrorByte,
   long *ErrorBit,
   long *ErrorBit_1_in_0,
   long *ErrorBit_0_in_1,
   int *ErrorPacketCRC,
   int *ErrorPacketSize,
   int *ErrorPacketACK)
{int i;
 int PN;
 int Code;
 int Attempt;
 int RxPacketNbr;
 int PacketNbr1;
 int PacketNbr;
 int RxPacketNbrComp;
 int RxPacketNbrWait;
 unsigned short CheckSum;
 unsigned short RxCheckSum;
 unsigned short RxCheckSum1;
 unsigned short RxCheckSum2;

 unsigned char BufferOrg[ PACKETSIZE ]; /*   묨 묨 */

 char Temp[80];
 extern int Time1, Time;
 time_t Start1;
 time_t Start;

 /* 砫 */
 PacketNbr = *PacketNbr2;
 PacketNbr1 = PacketNbr;
 PacketNbr &= 0x00ff;

#if DEBUG
sprintf(Temp,"[RxP: COM%d PacketNbr=%d PacketNbr1=%d NCGchar=%c EOTflag=%d PacketSize=%d]\n",
    1+Port,PacketNbr,PacketNbr1,NCGchar,*EOTptr,*PacketSizePtr);
WinPutString(SCR_WIN,Temp);
#endif

 /* ᮧ ୮  */
 if(PacketNbr1!=0){InitStatRnd(PacketNbr1);
   for(i=0;i<*PacketSizePtr;i++){
    Code=StatRnd();
    if(Code<25||Code==255) i--;
    else BufferOrg[i] = Code;
   }
 }

 (void)time(&Start1);

 for(Attempt=1;;Attempt++)
     {
   if(SioKeyPress())
     {sprintf(Temp,"Aborted by user");
      WriteMsg(Temp);
      TxCAN(Port);
      return(FALSE);
     }
      (void)time(&Start);
      for(;;)
      {
	/*  SOH */
	Code = CharGet(Port,SSHORT_WAIT);
        // ,  SHORT_WAIT ⠢ LONG_WAIT ᬮ timing.h !!!!!!!
	if(Code == SOH || Code == CAN || Code == EOT ) goto Cont;
	if( (int)(time(NULL) - Start) > WAIT_TIME ) goto Cont;
//	WriteFileBytes(Code);	/*  ਭ ᨬ  䠩 */
      }
Cont:
      switch((char)Code)
	  {case SOH:
	       /* 16  16 ... 16384  室騩  */
	       if(PacketNbr1==0) *PacketSizePtr = 16;
	       if(PacketNbr1!=0) *PacketSizePtr = *PacketSizePtr;
	       break;
	   case CAN:
		/* ਥ ⬥! */
                Code = CharGet(Port,SSHORT_WAIT);
                if(Code == CAN){
                sprintf(Temp,"Canceled by REMOTE");
	        PacketError(PacketNbr1,Attempt,Temp);
		return(FALSE);
                }
                SioDelay(XYDELAY);	     
                goto Again3;
	   case EOT:
		/* ᯥ譮 襭 ਥ */
		if(Time1 < Time){
		 Attempt = Attempt - 1;
		 SioDelay(XYDELAY);
		 goto Again3;
		}
		if(Time1 >= Time){
		 Code = CharPut(Port,ACK);
		 *EOTptr = TRUE;
		 return(TRUE);
		}
	   default:
		/* ਭ  SOH/EOT/CAN! */
		sprintf(Temp,"Not SOH/EOT/CAN");
		PacketError(PacketNbr1,Attempt,Temp);
		SioDelay(XYDELAY);
		Code = CharPut(Port,NAK);
		goto Again3;
	  }
      /* ਥ   */
      Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
      if(Code==-1)
	{PacketError(PacketNbr1,Attempt,"Not packet number");
	 *ErrorPacketSize = *ErrorPacketSize + 1;
	 SioDelay(XYDELAY);
	 Code = CharPut(Port,NAK);
	 goto Again;
	}
      RxPacketNbr = 0x00ff & Code;
      /* ਥ    */
      Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
      if(Code==-1)
	{PacketError(PacketNbr1,Attempt,"Not complement packet number");
	 sprintf(Temp,"Receive: %d, but %d",RxPacketNbr,PacketNbr);
	 WriteFile(Temp);
	 *ErrorPacketSize = *ErrorPacketSize + 1;
	 SioDelay(XYDELAY);
	 Code = CharPut(Port,NAK);
	 goto Again;
	}
      RxPacketNbrComp = 0x00ff & Code;
      /* ஢ઠ ਭ⮣   */
      if(RxPacketNbr+RxPacketNbrComp!=255)
	  {PacketError(PacketNbr1,Attempt,"Bad packet number");
	   sprintf(Temp,"Receive: %d %d, but %d",RxPacketNbr,RxPacketNbrComp,PacketNbr);
	   WriteFile(Temp);
#if DEBUG
sprintf(Temp,"[RxP: PacketNbr=%d RxPacketNbr=%d RxPacketNbrComp=%d]\n",
    PacketNbr,RxPacketNbr,RxPacketNbrComp);
WinPutString(SCR_WIN,Temp);
#endif
	   SioDelay(XYDELAY);
	   Code = CharPut(Port,NAK);
	   goto Again;
          }

      /*   ७? */
      else if(RxPacketNbr!=PacketNbr)
	  {PacketError(PacketNbr1,Attempt,"Not that packet number");
	   sprintf(Temp,"Receive: %d, but %d",RxPacketNbr,PacketNbr);
	   WriteFile(Temp);
	   sprintf(Temp,"Transfer receive other ACK or NAK");
	   WriteFile(Temp);

           if(PacketNbr1 == 1 && RxPacketNbr == 0)
           {
            SioDelay(XYDELAY);
            Attempt = 0;
            Code = CharPut(Port,ACK);
            goto Again3;
           }

	   Attempt = 0;
	   *ErrorPacketACK = *ErrorPacketACK + 1;

           //  ⮣,       255
           PN = (int)(*PacketNbr2 / 256);
           if( RxPacketNbr > 250 && PacketNbr < 10 ) PN = PN - 1;
           if( RxPacketNbr < 10 && PacketNbr > 250 ) PN = PN + 1;
           *PacketNbr2 = RxPacketNbr + PN * 256;        

	   PacketNbr = *PacketNbr2;
	   PacketNbr1 = PacketNbr;
	   PacketNbr &= 0x00ff;

	   /* ᮧ ୮  */
	 if(PacketNbr1!=0){InitStatRnd(PacketNbr1);
	   for(i=0;i<*PacketSizePtr;i++){
	       Code=StatRnd();
	       if(Code < 34 || Code == 255) i--;
	       else BufferOrg[i] = Code;
	   }
	 }
      }
      /* ਥ  */
      CheckSum = 0;
      for(i=0;i<*PacketSizePtr;i++)
	  {Code = CharGet(Port,LONG_WAIT*ONE_SECOND);
	   if(Code==-1)
	       {PacketError(PacketNbr1,Attempt,"Not data packet");
		sprintf(Temp,"Receive %d symbols from packet %d(%d)",i, PacketNbr1, PacketNbr);
		WriteFile(Temp);
		if(PacketNbr1!=0) Check(i,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"no data");
		Code = CharPut(Port,NAK);
		*ErrorPacketSize = *ErrorPacketSize + 1;
		goto Again;
	       }
	   Buffer[i] = Code;
	   /* ᫥ CRC  checksum */
	   if(NCGchar!=NAK) CheckSum = UpdateCRC((unsigned char)Code,CheckSum);
	   else CheckSum = (CheckSum + Code) & 0x00ff;
	  }
      /* ਥ CRC/checksum */
      if(NCGchar!=NAK)
	  {/* ਥ   CRC */
	   Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
	   if(Code==-1)
	       {PacketError(PacketNbr1,Attempt,"Not 1st CRC byte");
		if(PacketNbr1!=0) Check(*PacketSizePtr,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"no 1st CRC");
		Code = CharPut(Port,NAK);
		*ErrorPacketSize = *ErrorPacketSize + 1;
		goto Again;
	       }
	   RxCheckSum1 = Code & 0x00ff;
	   Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
	   if(Code==-1)
	       {PacketError(PacketNbr1,Attempt,"Not 2nd CRC byte");
		if(PacketNbr1!=0) Check(*PacketSizePtr,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"no 2st CRC");
		Code = CharPut(Port,NAK);
		*ErrorPacketSize = *ErrorPacketSize + 1;
		goto Again;
	       }
	   RxCheckSum2 = Code & 0x00ff;
	   RxCheckSum = (RxCheckSum1<<8) | RxCheckSum2;
	  }
      else
	  {/* ਥ   checksum */
	   Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
	   if(Code==-1)
	       {PacketError(PacketNbr1,Attempt,"Not checksum");
		if(PacketNbr1!=0) Check(*PacketSizePtr,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"no CRC");
		Code = CharPut(Port,NAK);
		*ErrorPacketSize = *ErrorPacketSize + 1;
		goto Again;
	       }
	   RxCheckSum = Code & 0x00ff;
	  }

       /* ஢ઠ checksum? */
      if(RxCheckSum!=CheckSum)
	  {PacketError(PacketNbr1,Attempt,"Bad packet CRC/checksum");
	   sprintf(Temp,"Receive checkbytes = %u, but %u in packet %d(%d)",RxCheckSum,CheckSum,PacketNbr1,PacketNbr);
	   WriteFile(Temp);
           if(PacketNbr1!=0) Check(*PacketSizePtr,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"bad CRC");
	   Code = CharPut(Port,NAK);
	   *ErrorPacketCRC = *ErrorPacketCRC + 1;
	   goto Again;

#if DEBUG
 sprintf(Temp,"RxPacket %d: Checksum: RX = %xH, Computed = %xH (%c)\n",
	RxPacketNbr,RxCheckSum,CheckSum,NCGchar);
 WinPutString(SCR_WIN,Temp);
#endif

          }
      else
	  {/* flush reverse channel */
	   SioRxFlush(Port);
	   /* ⢥ত ୮  ACK */
//         if(PacketNbr1!=0) Check(*PacketSizePtr,Buffer,BufferOrg,ErrorByte,ErrorBit,ErrorBit_1_in_0,ErrorBit_0_in_1,PacketNbr2,"O'K");
	   Code = CharPut(Port,ACK);
	   return(TRUE);
	  } /* end if */
Again:
      *ErrorPacket = *ErrorPacket + 1;
Again3:

      if( (int)(time(NULL) - Start1) > LIMIT ){
        sprintf(Temp,"Limit Time");
        PacketError(PacketNbr1,Attempt,Temp);
        return(FALSE);
      }

     } /* end -- for(Attempt) */
} /* end -- RxPacket */

void PacketError(int Packet, int Attempt, char *MsgPtr)
{char Temp[81];
// int _Packet;
// _Packet = Packet & 0x00ff;
// sprintf(Temp,"Packet %d(%d) Attempt %d %s",Packet,_Packet,Attempt,MsgPtr);
 sprintf(Temp,"Packet %d Attempt %d %s",Packet,Attempt,MsgPtr);
 WriteFile(Temp);
 WriteMsg(Temp);
}

int TxStartup(int Port,char *NCGcharPtr)
{int i;
 int Code;
 char Temp[30];
#if DEBUG
 sprintf(Temp,"### TxStartup");
 WinPutString(SCR_WIN,Temp);
#endif
 /* ⪠  Rx */
 SioRxFlush(Port);
 /* wait for receivers start up 'S' */
 for(i=1;i<LIMIT;i++)
   {if(SioKeyPress())
	  {sprintf(Temp,"Aborted by user");
           WriteMsg(Temp);
	   TxCAN(Port);
	   return(FALSE);
	  }
      Code = CharGet(Port,ONE_SECOND);
      /* ਥ ᨬ */
      WriteMsg("Using StatModem");
      if((char)Code=='S')
	 {*NCGcharPtr = (char)Code;
          Code = CharPut(Port,SOH);
          return TRUE;
	 }
     } /* end -- for(i) */
 /*  ⢥ */
 sprintf(Temp,"No response from receiver");
 WriteMsg(Temp);
 TxCAN(Port);
 return(FALSE);
} /* end -- TxStartup */

int RxStartup(int Port,char *NCGcharPtr)
{int i;
 int Code;
 char Temp[30];
#if DEBUG
 sprintf(Temp,"### RxStartup");
 WinPutString(SCR_WIN,Temp);
 sprintf(Temp," %c<%xH>\n",*NCGcharPtr,*NCGcharPtr);
 WinPutString(SCR_WIN,Temp);
#endif
 /* ⪠  Rx */
 SioRxFlush(Port);
 WriteMsg("Using StatModem");
 /* 뫪 'S' */
 for(i = 1;i < LIMIT;i++)
   {if(SioKeyPress())
    {WriteMsg("Canceled by USER");
     return(FALSE);
    }
      Code = CharPut(Port,*NCGcharPtr);
#if DEBUG
sprintf(Temp,"<%xH>",*NCGcharPtr);
WinPutString(SCR_WIN,Temp);
#endif
      Code = CharGet(Port,ONE_SECOND);
      if(Code == SOH) return(TRUE);
#if DEBUG
      sprintf(Temp,"OK <%xH>\n",Code);
      WinPutString(SCR_WIN,Temp);
#endif
     } /* end -- for(i) */
 /*  ⢥ */
 sprintf(Temp,"No response from sender");
 WriteMsg(Temp);
 TxCAN(Port);
 return(FALSE);
} /* end -- RxStartup */

int TxEOT(int Port)
{int i;
 int Code;
 for(i = 0;i < 10;i++)
     {Code = CharPut(Port,EOT);
      /*  ⢥ত */
      Code = CharGet(Port,SHORT_WAIT*ONE_SECOND);
      if((char)Code == ACK) return(TRUE);
     } /* end -- for(i) */
  return(FALSE);
 } /* end -- TxEOT */

#include "check.cpp"
