/***               --- term.cpp ---
**
**   ନ  ⮪ StatMODEM.
**
**  Link with ALLOCSEG, TERM_IO, MODEM_IO, CRC16, DOS, AMODEM,
**  STMODEM, STPACKET and WIN_IO.  TERM makefiles.
***/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <fcntl.h>
#include <string.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <malloc.h>
#include <dos.h>
#include <io.h>
#include "pcl4c.h"
#include "ascii.h"
#include "term.h"
#include "term_io.h"
#include "dos_io.h"
#include "modem_io.h"
#include "crc16.h"
#include "stmodem.h"
#include "term.h"
#include "allocseg.h"
#include "timing.h"
#include "win_io.h"
#include "workfile.h"

#include "term.cfg"

#define ATTN_CHAR  0x11
#define ABORT_CHAR CAN

#define FALSE 0
#define TRUE !FALSE
#define WORD unsigned int

#define NORMAL 0x07
#define INVERSE 0x70
#define MESSAGE_POS 48

/*  ⨯ */
void ProcessESC(void);
void ShowStatus(void);
void StatusMsg(char,char *);
void CheckWin(int);
void SetS(void);

/*  ६ */

#define SIOBUF_SIZE PACKETSIZE //16384
#define BLKBUF_SIZE PACKETSIZE //16384

int  Port;                /* ⥪騩 COM  [0..3] */
char FileName[15];        /*    䠩 ⨪ */
char FileNameTab[15];     /*    䠩 ⪮ ⨪ */
char Buffer[BLKBUF_SIZE]; /*   */
char *BaudRate[10] =  {"300","600","1200","2400","4800","9600",
                       "19200","38400","57600","115200"};
int  BaudCode;            /*  ࠧ襭 ᪮   BaudRate[] */
char NCGchar   = 'S';
char Protocol  = 'S';

int  Timeout   = 10;
int  EchoFlag  = TRUE;

int  PacketSize = 1024; /* ࠧ  */
int  CheckitByte = 2;   /* ᫮  ஢筮 樨 */
int  Time        = 15;  /* ६ ࠡ */
int  Time1;

char StatusAnswerModem[5] = "start";
char StatusProtocol[2] = "SS";
char Mode;
char Speed[6];
FILE *OutFile;
FILE *OutFileTab;

/***  ணࠬ ***/

void main(int argc,char *argv[])
{int DataFlag = FALSE;
 char c;
 int i, i1=0, i2=0, i3=0, k;
 int n, rc;
 char Temp[70];
 long _Number1K;

 /* ⨬  ᫮ ࠬ஢   ப? */
 if((argc<3)||(argc>4))
     {printf("Usage: 'TERM port baud mode((A)nswer, (O)riganete or (L)ine)'\n");
      printf("-- example 'TERM 1 9600 O'\n");
      exit(1);
     }
 /* ⨬   COM ? */
 Port = atoi(argv[1]) - 1;
 if((Port<0) || (Port>15))
     {printf("Port must be 1 to 16\n");
      exit(1);
     }

 /* ⨬  祭 ᪮? */
 BaudCode = BaudMatch(argv[2]);
 if(BaudCode<0)
     {printf("Cannot recognize baud rate = %s\n",argv[2]);
      exit(1);
     }

 /* ࠧ襭  ⠭ ०? */
 sprintf(Temp,"%s",argv[3]);
 Mode = Temp[0];
 if( ( Mode != 'A') && ( Mode != 'O' ) && ( Mode != 'L' ) )
     {printf("Mode must be A, O or L\n");
      exit(1);
     }

 sprintf(Speed,"%s",argv[2]);
 NameFile();
 NameFileTab();
 WriteInFile_("Start programm\n\n");
 sprintf(Temp,"Resetting COM%d at %s baud\n",Port+1,argv[2]);
 WriteFile(Temp);

 printf("Wait...Loading programm!\n");

 /*********************************************************/

 /* ⠭ ਥ  */
 ErrorCheck( SioRxBuf(Port,AllocSeg(2048),Size2K) );

 if(SioInfo('I'))
   {/* ⠭ ।饣  */
    ErrorCheck(SioTxBuf(Port,AllocSeg(2048),Size2K) );
   }

 /* ⠭ ࠬ஢   COM  */
 SioParms(Port,NoParity,OneStopBit,WordLength8);
 /* reset port */
 rc = SioReset(Port,BaudCode);
 if(rc<0) rc = SioReset(Port,BaudCode);
 if(rc<0)
   {printf("Cannot reset COM%d\n",1+Port);
    exit(1);
   }
 /* set DTR and RTS */
 SioDTR(Port,'S');
 SioRTS(Port,'S');

 /* ⠭   */
 CheckWin( WinCreate(SCR_WIN,  0,0, 23,79) );
 CheckWin( WinNormal(SCR_WIN) );
 CheckWin( WinClear(SCR_WIN) );
 /* ⠭    */
 CheckWin( WinCreate(LFT_WIN, 24,0, 24,30) );
 CheckWin( WinInverse(LFT_WIN) );
 CheckWin( WinClear(LFT_WIN) );
 /* ⠭ ࠢ   */
 CheckWin( WinCreate(RGT_WIN, 24,32, 24,79) );
 CheckWin( WinInverse(RGT_WIN) );
 CheckWin( WinClear(RGT_WIN) );
 /*     ࠭ */
 ShowStatus();
 /*  ன ଠ樨 */
 WinPutString(SCR_WIN,"  -- TERM: 24/09/98 -- Ver.2.20 -- Author: Serge V. Mukhin --\n\n");
 WinPutString(SCR_WIN,"   Parameters: 8N1\n");
#if 0 /* RTS_CTS_CONTROL */
 SioFlow(Port,10*ONE_SECOND);
 WinPutString(SCR_WIN," Flow Control: YES\n");
#else
 WinPutString(SCR_WIN," Flow Control: NO\n");
#endif
 /* ⠭ ஢ FIFO */
 WinPutString(SCR_WIN,"   16550 UART: ");
 if( SioFIFO(Port,LEVEL_14) ) WinPutString(SCR_WIN,"YES\n");
 else WinPutString(SCR_WIN,"NO\n");
 /* ⪠ ਥ  PCL4C */
 ErrorCheck( SioRxFlush(Port) );
 WinPutChar(SCR_WIN,'\n');

#if 0
 /* wait for Modem to say its ready */
 WinPutString(SCR_WIN,"  <<Waiting for Modem DSR>>\n");
 while( !SioDSR(Port) )
     {if(SioKeyPress()||SioBrkKey()) MyExit(0,"Aborted by user");
      WinPutChar(SCR_WIN,'.');
      SioDelay(18);
     }
 WinPutString(SCR_WIN,"  <<DSR on>>\n");
#endif

#if 0 /* RTS_CTS_CONTROL */
 WinPutString(SCR_WIN,"  <<Waiting for Modem CTS>>\n");
 while( !SioCTS(Port) )
     {if(SioKeyPress()||SioBrkKey()) MyExit(0,"Aborted by user");
      WinPutChar(SCR_WIN,'.');
      SioDelay(18);
     }
 WinPutString(SCR_WIN,"  <<CTS on>>\n");
#endif

#if 1 /* AT_COMMAND_SET */
 /* 樠 Hayes ᮢ⨬  */
 if(Mode != 'L'){
 ModemSendTo(Port,4,"AT!");
 ModemEcho(Port,10);
 }
 if(Mode == 'A'){
	ModemSendTo(Port,4,"ATS0=1!");
	ModemEcho(Port,10);
 }
#endif
 SetS();

 /* enter terminal loop */
 SioRxFlush(Port);
 WinPutString(SCR_WIN,"  <<Entering terminal loop>>\n");
 while(1)
     {/* Control-BREAK ? */
      if(SioBrkKey()) MyExit(0,"User pressed Ctrl-BREAK");
      /*   ? */
      if(SioKeyPress())
	  {/* ⥭ ⮩  */
	   i = SioKeyRead();
	   /* ^B sends BREAK */
	   if((char)i=='\02')
	       {/* send break */
		WriteMsg("Sending BREAK");
		SioBrkSig(Port,'A');
		SioDelay(10);
		SioBrkSig(Port,'C');
	       }
	   else if((char)i==ATTN_CHAR)
	       {/* process user's request */
		ProcessESC();
		ShowStatus();
		continue;
	       }
	   else CharPut(Port,(char)i);
	  }
      /* was break detected ? */
      if( SioBrkSig(Port,'D') ) WriteMsg("BREAK detected ");
      /* any incoming over serial port ? */
      i = CharGet(Port,1);
      if(i>-1)
	  {/* good character */
	   if(DataFlag&((i<0x20)||(i>0x7e)))
	       {WinPutChar(SCR_WIN,'^');
		WinPutChar(SCR_WIN,(char)('@'+i));
	       }
	   else{ WinPutChar(SCR_WIN,(char)i);
		 WriteFileBytes(i); /* save in file byte */

		 if( char(i) == 'C') i3 = 1;
		 if( i3 == 1) WriteFileBytes_(i); /* save in file CONNECT */
		 if( i3 == 1 && char(i) == '\n') i3 = 0;

		 if( i == int(StatusAnswerModem[i1]) && Mode == 'A' ) i1++;
		 else i1 = 0;
		 if( i1 == 5 ){
			SioDelay(50);
			StatusMsg(ABORT_CHAR,"aborts");
			SmodemRx(Port,Buffer,NCGchar);
			i1 = 0;
		 }
		 if( i == int( StatusProtocol[i2]) ) i2++;
		 else i2 = 0;
		 if( i2 == 2 ){
			StatusMsg(ABORT_CHAR,"aborts");
			SmodemTx(Port,Buffer);
			if( Mode == 'O' ){
			  StatusMsg(ABORT_CHAR,"aborts");
			  SmodemRx(Port,Buffer,NCGchar);
			  }
		 }
	       }
	  }
     } /* end -- key pressed */
}

/*** find baud rate string in table ***/

int BaudMatch(char *ptr)
{int i;
 /* find baud rate in table */
 for(i=0;i<10;i++) if(strcmp(BaudRate[i],ptr)==0) return(i);
 return(-1);
}

/*** user pressed Escape */

void ProcessESC(void)
{int i;
 int c1;
 char Answer[5]; /* answer array */
 char Temp[60];
 int  PacketSizeTab[10] = { 1024, 512, 2048, 32, 64, 256, 16, 8192, 128, 4096 };
 int  PacketSizeTab1[4] = { 8192, 32762, PACKETSIZE, 16384 };
 /* user pressed ATTN_CHAR */
 Answer[0] = '?';
 Answer[1] = '\0';
 Answer[2] = '\0';
 WriteMsg("Q)uit P)rotocol S)end R)eceive E)xper: ");
 ReadMsg(Answer,1,39);
 if(strlen(Answer)) switch(toupper(Answer[0]))
     {case 'E':
	  WriteMsg("H)ang up S)tart P)arametrs: ");
	  ReadMsg(Answer,1,29);
	  if(strlen(Answer)) switch( toupper(Answer[0]) )
	       {case 'H':
			 sprintf(Temp,"Hang Up");
			 WriteMsg(Temp);
			 ModemHangup(Port);
		break;
		case 'S':
			 sprintf(Temp,"Start works");
			 WriteMsg(Temp);
			 CharPut(Port,'s');
			 CharPut(Port,'t');
			 CharPut(Port,'a');
			 CharPut(Port,'r');
			 CharPut(Port,'t');
		break;
		case 'P':
			 sprintf(Temp,"PacketSize=%d bytes Time=%d min Check=CRC16",PacketSize,Time);
			 WriteMsg(Temp);
		break;
		default:
			 WriteMsg("Must answer H, S or P");
		break;
	       }
	  break;
      case 'P':
	  WriteMsg("M)packetSize P)acketSize PacketS)ize T)ime: ");
	  ReadMsg(Answer,1,45);
	  if(strlen(Answer)) switch( toupper(Answer[0]) )
	       {case 'M':
		    sprintf(Temp,"PacketSize ( < %d byte ):",PACKETSIZE);
		    WriteMsg(Temp);
		    ReadMsg(Answer,5,30);
		    PacketSize=atoi(Answer);
		    if(PacketSize >= PACKETSIZE || PacketSize < 0) PacketSize = PACKETSIZE;
		    sprintf(Temp,"PacketSize = %d byte",PacketSize);
		    WriteMsg(Temp);
		break;
		case 'S':
		    WriteMsg("81)92 16384) 32)762 653)24 131072: ");
		    ReadMsg(Answer,1,36);
		    c1=(int)Answer[0];
		    if( c1 >= 49 && c1 <= 52 ){
			PacketSize = PacketSizeTab1[c1-48-1];
		        if(PacketSize >= PACKETSIZE || PacketSize < 0) PacketSize = PACKETSIZE;
			sprintf(Temp,"PacketSize = %d bytes",PacketSize);
			WriteMsg(Temp);
		    }
		    else if( c1 < 49 || c1 > 52 ) WriteMsg("Must answer 1, 2, 3 or 4");
		break;
		case 'P':
		     WriteMsg("16) 3)2 64) 128) 25)6 51)2 10)24 2)048 409)6: ");
		     ReadMsg(Answer,1,46);
		     c1=(int)(Answer[0]);
		    if(c1 >= 48 && c1 <=57 ){
			PacketSize = PacketSizeTab[c1-48];
		        if(PacketSize >= PACKETSIZE || PacketSize < 0) PacketSize = PACKETSIZE;
			sprintf(Temp,"PacketSize = %d bytes",PacketSize);
			WriteMsg(Temp);
		    }
		    else if(c1 < 48 || c1 > 57) WriteMsg("Must answer 6, 3, 4, 8, 5, 1, 9, 0 or 2");
		break;
		case 'T':
		     WriteMsg("Time works transfer(recomend 15):");
		     ReadMsg(Answer,3,34);
		     Time=atoi(Answer);
		     sprintf(Temp,"Time = %d min",Time);
		     WriteMsg(Temp);
		break;
		default:
		    WriteMsg("Must answer C, S, P or T");
		break;
	       }
	  ShowStatus();
	  break;
      case 'Q':
	  MyExit(0,"User QUIT");
	  break;
      case 'R':
	  StatusMsg(ABORT_CHAR,"aborts");
	  switch(Protocol)
	     {case 'S':
		 SmodemRx(Port,Buffer,NCGchar);
		 break;
	     }
	  while(SioKeyPress()) SioKeyRead();
	  break;
      case 'S':
	  StatusMsg(ABORT_CHAR,"aborts");
	  switch(Protocol)
	     {case 'S':
		 SmodemTx(Port,Buffer);
		 break;
	     }
	  while(SioKeyPress()) SioKeyRead();
	  break;
     default:
	  WriteHexMsg("Must answer Q, P, S, R, or E, not ",*Answer);
	  break;
    } /* end switch */
}

/*  ଠ樨    ࠭ */

void StatusMsg(char Attn,char *Msg)
{char Temp[50];
 sprintf(Temp," COM%d %s %c [ ^%c %s ]",
	 1+Port,BaudRate[BaudCode],Protocol,Attn+'@',Msg);
 WinClear(LFT_WIN);
 WinPutString(LFT_WIN,Temp);
 WinGetPos(SCR_WIN,NULL,NULL);
}

void ShowStatus(void)
{
 StatusMsg(ATTN_CHAR,"for Menu");
}

/* 室  ணࠬ */

void MyExit(int code, char *msg)
{int i;
 char Temp[80];
 if(code<0)
    {WinPutChar(SCR_WIN,' ');
     SioError(code);
     WinPutChar(SCR_WIN,'\n');
    }
 SioDone(Port);
 sprintf(Temp,"\rTERMINATING: %s\n",msg);
 WinPutString(SCR_WIN,Temp);
 SetCursor(6,7);

 sprintf(Temp,"Finish programm");
 WriteFile(Temp);
 fclose(OutFile);

 exit(0);
}

/* check for error */

void ErrorCheck(int Code)
{/* trap PCL error codes */
 if(Code<0)
     {
      WinPutChar(SCR_WIN,' ');
      SioError(Code);
      SioDone(Port);
      exit(1);
     }
} /* end ErrorCheck */

int GetBufSize(void)
{int BufSize = SIOBUF_SIZE;
 return BufSize;
}

void CheckWin(int n)
{if(n<0)
  {printf("\nWin error %d\n\n",n);
   exit(1);
  }
}

/* ⠭ ࠬ஢ ⮪ */

void SetS(void)
{Protocol = 'S';
 NCGchar = 'S';
 WriteMsg("Protocol = StatMODEM");
}

#include "calc.cpp"
#include "workfile.cpp"
