/*** TERM_IO.CPP ***/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pcl4c.h"
#include "term_io.h"
#include "ascii.h"
#include "dos_io.h"
#include "win_io.h"

#define FALSE 0
#define TRUE !FALSE
#define QUE_MASK 0x0f

static int EchoFlag = FALSE;
static  char Temp[80];

void MsgEcho(int Flag)
{EchoFlag = Flag;
}

/* write message to right status line */

void WriteMsg(char *MsgPtr)
{if(EchoFlag)
   {WinPutString(SCR_WIN,MsgPtr);
    WinPutChar(SCR_WIN,'\n');
   }
 WinClear(RGT_WIN);
 WinPutChar(RGT_WIN,' ');
 WinPutString(RGT_WIN,MsgPtr);
 WinGetPos(SCR_WIN,NULL,NULL);
}

/*** write message + integer parm */

void WriteIntMsg(char *MsgPtr, int Parm)
{char Temp[50];
 sprintf(Temp,"%s %d", MsgPtr, Parm);
 WriteMsg(Temp);
}

/*** write message + hexidecimal parm */

void WriteHexMsg(char *MsgPtr, int Parm)
{char Temp[50];
 sprintf(Temp,"%s 0x%x", MsgPtr, Parm);
 WriteMsg(Temp);
}

/*** write message + long parm */

void WriteLongMsg(char *MsgPtr, long Parm)
{char Temp[50];
 sprintf(Temp,"%s %ld", MsgPtr, Parm);
 WriteMsg(Temp);
}

/*** read message */

void ReadMsg(char *Buffer,int Length,int StartCol)
{WinSetPos(RGT_WIN,0,StartCol);
 WinGetString(RGT_WIN,Buffer,Length);
 WinGetPos(SCR_WIN,NULL,NULL);
}

/*** output character to serial port ***/

int CharPut(int Port, char ch)
{int i, rc;
 /* transmit character */
 rc = SioPutc(Port,ch);
 if(rc<0)
     {sprintf(Temp,"SioPutc Error: COM%d: ",1+Port);
      WinPutString(SCR_WIN,Temp);
      SioError(rc);
      WinPutChar(SCR_WIN,'\n');
      SioDone(Port);
      exit(1);
     }
 return(rc);
}

/*** receive character from serial port ***/

int CharGet(int Port, int Timeout)
{int rc;
 rc = SioGetc(Port,Timeout);
 if(rc<-1)
     {sprintf(Temp,"SioGetc Error: COM%d: ",1+Port);
      WinPutString(SCR_WIN,Temp);
      SioError(rc);
      exit(1);
     }
 return(rc);
}

/* display CPS */

int WriteCPS(long Secs,int packetsize,int packet,int errorpacket,char type)
{int  CPS;
 long FileBytes;
 int our, min, sec;
 char Temp[60];
 if(packet<0) packet=0;
// FileBytes = (long)packet * (long)packetsize;
 FileBytes = ((long)packet + (long)errorpacket)* (long)packetsize;
 if(Secs==0) Secs = 1;
 our=(int)(Secs/3600);
 min=(int)((Secs-our*3600)/60);
 sec=(int)((Secs-our*3600-min*60));
 CPS = (int) ( (long)packet * (long)packetsize / Secs);
// sprintf(Temp,"Packet %d CPS %d (%ld bytes) %02d:%02d:%02d",
//	       packet, CPS,FileBytes,our,min,sec);
 sprintf(Temp,"Packet %d Error %d Bytes %ld %02d:%02d:%02d%c",
	       packet,errorpacket,FileBytes,our,min,sec,type);
 WriteMsg(Temp);
 return CPS;
}
